//+------------------------------------------------------------------+
//|                                Intraday Momentum index   IMI.mq4 |
//|                      Copyright  2011, sahlih2000@gmail.com      |
//|                                      http://www.fx-arbia.com/vb/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, sahlih2000@gmail.com "
#property link      "http://www.fx-arbia.com/vb/"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 CLR_NONE
#property indicator_color3 CLR_NONE

#property indicator_level1 70
#property indicator_level2 30



extern int period=14;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(2,ExtMapBuffer3);
//----


IndicatorShortName("IMI ("+period+")");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   
   for(int i=0;i<=Bars-(period+9);i++)
   {
   
   double A=iClose(0,0,i)-iOpen(0,0,i);
   
   if(A>0 ){ ExtMapBuffer2[i]=A; ExtMapBuffer3[i]=0; }
   if(A<=0){ ExtMapBuffer2[i]=0; ExtMapBuffer3[i]=MathAbs(A); }
   
   
 
   }
     
     
      
      for( i=0;i<=Bars-period;i++)
   {
   
   double SumUP=0,SumDow=0;
   
   int I=i;
   
   for(int j=i;j<=period+i;j++){
   
   SumUP=  SumUP    +    ExtMapBuffer2[j];
   SumDow= SumDow   +    ExtMapBuffer3[j];
   
   I=I+1;
  }
   
   double UP_Plus_Dow=SumUP+SumDow;
   
   double IMI=(SumUP/(SumUP+SumDow))*100;
   
   ExtMapBuffer1[i]=IMI;
   
   
   }
   
 
 
   
   

   return(0);
  }
//+------------------------------------------------------------------+